> For the complete documentation index, see [llms.txt](https://docs.movesdk.com/move-platform/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.movesdk.com/move-platform/sdk/appendix/android/battery-optimization.md).

# Battery optimization

### Request battery optimization whitelist

Android has various power-saving modes across all manufacturers. One common feature is the [doze mode](https://developer.android.com/training/monitoring-device-state/doze-standby). This mode prevents the application from wakeup and has a negative impact on detection of the MOVE SDK. To circumvent this, the application can request to be whitelisted for such optimizations.&#x20;

```kotlin
fun isIgnoringBatteryOptimizations(context: Context): Boolean {
    val pm = context.getSystemService(Context.POWER_SERVICE) as PowerManager
    return pm.isIgnoringBatteryOptimizations(context.packageName)
}

@SuppressLint("BatteryLife")
fun requestIgnoreBatteryOptimization(activity: Activity) {
    if (!isIgnoringBatteryOptimizations(activity)) {
        val intent = Intent(Settings.ACTION_REQUEST_IGNORE_BATTERY_OPTIMIZATIONS).apply {
            data = Uri.parse("package:${activity.packageName}")
        }
        try {
            activity.startActivityForResult(intent, BATTERY_REQUEST_CODE)
        } catch (t: Throwable) {
            // handle exception
        }
    }
}
```

![Ignore battery optimizations](/files/-Mcxo-EBAfcTCX0pott3)

{% hint style="warning" %}
Requesting battery optimizations is not mandatory, but strongly recommended.
{% endhint %}

{% hint style="danger" %}
Google Play allows this request only if the core functionality is impacted. Depending on your usecase of the app it may get suspended / rejected from the Play Store. Please check the[ offical docs](https://developer.android.com/training/monitoring-device-state/doze-standby#exemption-cases) for additional information.&#x20;
{% endhint %}

## Third party battery saving

Some manufacturers have their own implementations of battery saving features. Since we cannot cover all manufacturers here, a nice source for tips of keeping the app alive can be found at [dontkillmyapp](https://dontkillmyapp.com/).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.movesdk.com/move-platform/sdk/appendix/android/battery-optimization.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
